Hot News:

Unser Angebot:

  Foren auf CAD.de (alle Foren)
  Inventor VBA
  Auflösung/Größe Thumbnail

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
  
Gut zu wissen: Hilfreiche Tipps und Tricks aus der Praxis prägnant, und auf den Punkt gebracht für Autodesk Produkte
Autor Thema:  Auflösung/Größe Thumbnail (132 mal gelesen)
HansPeterNew
Mitglied
Technisches Büro


Sehen Sie sich das Profil von HansPeterNew an!   Senden Sie eine Private Message an HansPeterNew  Schreiben Sie einen Gästebucheintrag für HansPeterNew

Beiträge: 26
Registriert: 19.10.2021

erstellt am: 23. Nov. 2021 10:01    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo,

brauche nochmal Hilfe. Gibt es eine Möglichkeit die Größe/Auflösung der Vorschaubilder beim Stücklistenexport der .iam nach Excel zu ändern?
Wir verwenden IV2021 und würden die Vorschaubilder auch für das ERP verwenden. Leider sind die Bilder aber sehr klein mit geringer Auflösung.
Vielen Dank inzwischen...
Hans Peter

------------------
Beste Grüße
Hans Peter

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

KraBBy
Mitglied
Maschinenbau-Ingenieur


Sehen Sie sich das Profil von KraBBy an!   Senden Sie eine Private Message an KraBBy  Schreiben Sie einen Gästebucheintrag für KraBBy

Beiträge: 465
Registriert: 19.09.2007

Inventor Professional 2020
WinX

erstellt am: 24. Nov. 2021 17:31    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für HansPeterNew 10 Unities + Antwort hilfreich

Damit habe ich mich bisher noch nicht befasst. Ich konnte jetzt in der API-Hilfe keine Option dazu finden.
Bild selber erstellen?

Camera.SaveAsBitmap Method

Camera.CreateImage Method
das wäre ein Bild im Arbeitsspeicher, ohne eine Datei zu erzeugen. kA wie man das ins Excel wirft

------------------
Gruß KraBBy

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

rkauskh
Moderator
Dipl.-Ing. (FH) Versorgungstechnik


Sehen Sie sich das Profil von rkauskh an!   Senden Sie eine Private Message an rkauskh  Schreiben Sie einen Gästebucheintrag für rkauskh

Beiträge: 1913
Registriert: 15.11.2006

Windows 10 x64, AIP 2021

erstellt am: 24. Nov. 2021 23:29    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für HansPeterNew 10 Unities + Antwort hilfreich

Hallo

Das Thumbnail ist nicht veränderlich. Bleiben die Bilder in der Exceltabelle oder wo liegen die Bilder, damit das ERP darauf zugreifen kann? Werden die Bilder in der Datenbank des ERP gespeichert oder liegen die extern auf einem Share? Wie wird die Stückliste übergeben? Ist das ein Script in dem man etwas ergänzen oder dazwischen springen kann?

So in etwa sollte das funktionieren. Ist iLogic, kann man aber auch in VBA übersetzen.

Code:

Option Explicit on
Dim oApp As Inventor.Application = ThisApplication
Dim oDoc As Document = ThisDoc.Document
Dim sFilename As String = ThisDoc.FileName(False)
Dim oTrans As Transaction= oApp.TransactionManager.StartTransaction(oDoc, "PicEX ")
Dim oCurView As View= oApp.ActiveView

Try
oApp.ScreenUpdating = False
Dim oView As View= oDoc.Views.Add()
Dim oCamera As Camera= oView.Camera

oCamera.ViewOrientationType = kIsoTopRightViewOrientation
oCamera.Fit
oCamera.ApplyWithoutTransition

Dim oColor As Color= oApp.TransientObjects.CreateColor(255, 255, 255)
Call oCamera.SaveAsBitmap("C:\Temp\" & sFilename & ".jpg", 1920, 1080, oColor)

oView.Close
oCurView.Activate
Catch
Finally
oTrans.Abort
oApp.ScreenUpdating = True

oDoc.Update
End Try



------------------
MfG
Ralf

RKW Solutions GmbH
www.RKW-Solutions.com

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

HansPeterNew
Mitglied
Technisches Büro


Sehen Sie sich das Profil von HansPeterNew an!   Senden Sie eine Private Message an HansPeterNew  Schreiben Sie einen Gästebucheintrag für HansPeterNew

Beiträge: 26
Registriert: 19.10.2021

erstellt am: 25. Nov. 2021 09:23    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Zitat:
Original erstellt von rkauskh:
Hallo

Das Thumbnail ist nicht veränderlich. Bleiben die Bilder in der Exceltabelle oder wo liegen die Bilder, damit das ERP darauf zugreifen kann? Werden die Bilder in der Datenbank des ERP gespeichert oder liegen die extern auf einem Share? Wie wird die Stückliste übergeben? Ist das ein Script in dem man etwas ergänzen oder dazwischen springen kann?

So in etwa sollte das funktionieren. Ist iLogic, kann man aber auch in VBA übersetzen.

Code:

Option Explicit on
Dim oApp As Inventor.Application = ThisApplication
Dim oDoc As Document = ThisDoc.Document
Dim sFilename As String = ThisDoc.FileName(False)
Dim oTrans As Transaction= oApp.TransactionManager.StartTransaction(oDoc, "PicEX ")
Dim oCurView As View= oApp.ActiveView

Try
oApp.ScreenUpdating = False
Dim oView As View= oDoc.Views.Add()
Dim oCamera As Camera= oView.Camera

oCamera.ViewOrientationType = kIsoTopRightViewOrientation
oCamera.Fit
oCamera.ApplyWithoutTransition

Dim oColor As Color= oApp.TransientObjects.CreateColor(255, 255, 255)
Call oCamera.SaveAsBitmap("C:\Temp\" & sFilename & ".jpg", 1920, 1080, oColor)

oView.Close
oCurView.Activate
Catch
Finally
oTrans.Abort
oApp.ScreenUpdating = True

oDoc.Update
End Try




Hallo Ralf,

ich schon wieder.
vielen Dank. Damit können wir super arbeiten.
Hab den Pfad noch dazugenommen.
Leider kommt nach einer Änderung beim Ausführen ein Fehler.
Auch bei deiner Regel funkt das beim 2. mal ausführen nach einer Änderung nicht. (Hab es bei einer Baugruppe verucht)
Kannst du mir da helfen?

Option Explicit on
Dim oApp As Inventor.Application = ThisApplication
Dim oDoc As Document = ThisDoc.Document
Dim sFilename As String = ThisDoc.PathAndFileName(False)
Dim oTrans As Transaction= oApp.TransactionManager.StartTransaction(oDoc, "PicEX ")
Dim oCurView As View= oApp.ActiveView
Try
oApp.ScreenUpdating = False
Dim oView As View= oDoc.Views.Add()
Dim oCamera As Camera= oView.Camera

oCamera.ViewOrientationType = kIsoTopRightViewOrientation
oCamera.Fit
oCamera.ApplyWithoutTransition

Dim oColor As Color = oApp.TransientObjects.CreateColor(255, 255, 255)
Call oCamera.SaveAsBitmap(sFilename & ".jpg", 1920, 1080, oColor)


oView.Close
oCurView.Activate
Catch
Finally
oTrans.Abort
oApp.ScreenUpdating = True

oDoc.Update
End Try

------------------
Beste Grüße
Hans Peter

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

HansPeterNew
Mitglied
Technisches Büro


Sehen Sie sich das Profil von HansPeterNew an!   Senden Sie eine Private Message an HansPeterNew  Schreiben Sie einen Gästebucheintrag für HansPeterNew

Beiträge: 26
Registriert: 19.10.2021

erstellt am: 25. Nov. 2021 11:31    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


Screenshot2021-11-25112924.jpg


Screenshot2021-11-25113009.jpg

 
Hallo Ralf,

hier noch meine Fehlermeldungen.
Hans Peter

------------------
Beste Grüße
Hans Peter

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

rkauskh
Moderator
Dipl.-Ing. (FH) Versorgungstechnik


Sehen Sie sich das Profil von rkauskh an!   Senden Sie eine Private Message an rkauskh  Schreiben Sie einen Gästebucheintrag für rkauskh

Beiträge: 1913
Registriert: 15.11.2006

Windows 10 x64, AIP 2021

erstellt am: 25. Nov. 2021 15:03    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für HansPeterNew 10 Unities + Antwort hilfreich

Hallo

Ergänze mal bitte die Catch Anweisung was in der Fehlermeldung dann drin steht. Was wurde wie geändert? Hab jetzt einige Varianten durchprobiert ohne Fehler. Läuft der Code über einen Trigger (welcher?) oder manuell ausgelöst? Wenn nach dem ersten Durchlauf das Bild manuell gelöscht wird, kommt der Fehler dann trotzdem?

Code:

Option Explicit on
Dim oApp As Inventor.Application = ThisApplication
Dim oDoc As Document = ThisDoc.Document
Dim sFilename As String = ThisDoc.PathAndFileName(False)
Dim oTrans As Transaction= oApp.TransactionManager.StartTransaction(oDoc, "PicEX ")
Dim oCurView As View= oApp.ActiveView

Try
oApp.ScreenUpdating = False
Dim oView As View= oDoc.Views.Add()
Dim oCamera As Camera= oView.Camera

oCamera.ViewOrientationType = kIsoTopRightViewOrientation
oCamera.Fit
oCamera.ApplyWithoutTransition

Dim oColor As Color= oApp.TransientObjects.CreateColor(255, 255, 255)
Call oCamera.SaveAsBitmap(sFilename & ".jpg", 1920, 1080, oColor)

oView.Close
oCurView.Activate
Catch ex As Exception
MsgBox(ex.Message)
Finally
oTrans.Abort
oApp.ScreenUpdating = True

oDoc.Update
End Try


------------------
MfG
Ralf

RKW Solutions GmbH
www.RKW-Solutions.com

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

HansPeterNew
Mitglied
Technisches Büro


Sehen Sie sich das Profil von HansPeterNew an!   Senden Sie eine Private Message an HansPeterNew  Schreiben Sie einen Gästebucheintrag für HansPeterNew

Beiträge: 26
Registriert: 19.10.2021

erstellt am: 25. Nov. 2021 15:33    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Ralf,

Code:

Option Explicit on
Dim oApp As Inventor.Application = ThisApplication
Dim oDoc As Document = ThisDoc.Document
Dim sFilename As String = ThisDoc.PathAndFileName(True)
Dim oTrans As Transaction= oApp.TransactionManager.StartTransaction(oDoc, "PicEX ")
Dim oCurView As View= oApp.ActiveView
Try
oApp.ScreenUpdating = False
Dim oView As View= oDoc.Views.Add()
Dim oCamera As Camera= oView.Camera

oCamera.ViewOrientationType = kIsoTopRightViewOrientation
oCamera.Fit
oCamera.ApplyWithoutTransition

Dim oColor As Color = oApp.TransientObjects.CreateColor(255, 255, 255)
Call oCamera.SaveAsBitmap(sFilename & ".jpg", 1920, 1080, oColor)


oView.Close
oCurView.Activate
Catch ex As Exception
MsgBox(ex.Message)
Finally
oTrans.Abort
oApp.ScreenUpdating = True

oDoc.Update
End Try


Ich hab eigentlich nur Zeile 4
Dim sFilename As String = ThisDoc.PathAndFileName(True)
und Zeile 17 geändert
Call oCamera.SaveAsBitmap(sFilename & ".jpg", 1920, 1080, oColor)

Funktioniert auch soweit super.
Der Code läuft vor dem Speichern von Dokument.
Der Fehler taucht nur auf, sobald ich ein Teil in der Baugruppe lösche und nochmal speichern möchte.
Dann stürzt IV komplett ab.

------------------
Beste Grüße
Hans Peter

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

rkauskh
Moderator
Dipl.-Ing. (FH) Versorgungstechnik


Sehen Sie sich das Profil von rkauskh an!   Senden Sie eine Private Message an rkauskh  Schreiben Sie einen Gästebucheintrag für rkauskh

Beiträge: 1913
Registriert: 15.11.2006

Windows 10 x64, AIP 2021

erstellt am: 25. Nov. 2021 20:43    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für HansPeterNew 10 Unities + Antwort hilfreich

Hallo

Warum genau er da den Transactionsabbruch nicht mag weiß ich grade auch nicht. Geht aber auch ohne. Mit der Variante tritt der Fehler nicht mehr auf.

Code:

Option Explicit on
Dim oApp As Inventor.Application = ThisApplication
Dim oDoc As Document = ThisDoc.Document
Dim sFilename As String = ThisDoc.PathAndFileName(False)
Dim oCurView As Inventor.View= oApp.ActiveView

Try
oApp.ScreenUpdating = False
Dim oView As Inventor.View = oDoc.Views.Add()
oView.Visible = False

Dim oCamera As Camera = oView.Camera

oCamera.ViewOrientationType = kIsoTopRightViewOrientation
oCamera.Fit
oCamera.ApplyWithoutTransition

Dim oColor As Color= oApp.TransientObjects.CreateColor(255, 255, 255)
Call oCamera.SaveAsBitmap(sFilename & ".jpg", 1920, 1080, oColor)

oView.Close
Catch ex As Exception
MsgBox(ex.Message)
Finally
oApp.ScreenUpdating = True
End Try


------------------
MfG
Ralf

RKW Solutions GmbH
www.RKW-Solutions.com

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

HansPeterNew
Mitglied
Technisches Büro


Sehen Sie sich das Profil von HansPeterNew an!   Senden Sie eine Private Message an HansPeterNew  Schreiben Sie einen Gästebucheintrag für HansPeterNew

Beiträge: 26
Registriert: 19.10.2021

erstellt am: 26. Nov. 2021 11:13    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo Ralf,

ich hab die Regel jetzt in die Vorlage für Blech und Normbauteil kopiert.
Jetzt kommt wieder ein Fehler beim Speichern.
     

------------------
Beste Grüße
Hans Peter

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

HansPeterNew
Mitglied
Technisches Büro


Sehen Sie sich das Profil von HansPeterNew an!   Senden Sie eine Private Message an HansPeterNew  Schreiben Sie einen Gästebucheintrag für HansPeterNew

Beiträge: 26
Registriert: 19.10.2021

erstellt am: 26. Nov. 2021 15:41    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo,

habs inzwischen selber gelöst.
Den Trigger nach dem Speichern gesetzt und gepasst.
Vielen Dank für die kompetente und schnelle Hilfe.

------------------
Beste Grüße
Hans Peter

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

rkauskh
Moderator
Dipl.-Ing. (FH) Versorgungstechnik


Sehen Sie sich das Profil von rkauskh an!   Senden Sie eine Private Message an rkauskh  Schreiben Sie einen Gästebucheintrag für rkauskh

Beiträge: 1913
Registriert: 15.11.2006

Windows 10 x64, AIP 2021

erstellt am: 26. Nov. 2021 16:02    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für HansPeterNew 10 Unities + Antwort hilfreich

Hallo

Wenn das in einer Vorlage steckt und du das erste Mal speicherst, vermute ich das ThisDoc.PathAndFileName noch leer ist. Das wird ja intern wahrscheinlich vom Document.FullFilename abgeleitet. Du könntest prüfen, ob der leer ist. Dann müßte man schauen ob und wie man alternativ den Pfad und Dateinamen für den Export generiert.
Das wäre wieder ein Vorteil eines Addins. Dort kann man aus dem Context des OnSave Events unter anderem den FullFileName auslesen, in den das Dokument gespeichert werden soll.

Aber wenn es mit "Nach dem Speichern" funktioniert, einfach lassen und nicht rumfummeln. 

------------------
MfG
Ralf

RKW Solutions GmbH
www.RKW-Solutions.com

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2021 CAD.de | Impressum | Datenschutz